import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
import java.util.ArrayList;

/**
 * Write a description of class Level here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Level extends World
{
    public int key;    
    public Player player;
    Lover lover;
    public Pair pair;

    GreenfootSound beat;
    public boolean paired; //used to see if player has paired
    int beatTick;
    /**
     * Constructor for objects of class Level.
     */
    public Level()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(800, 600, 1); 
        paired = false;
        setBackground("weave.jpg");

        beat = new GreenfootSound("beat2.wav");
        beatTick = 0;
    }

    /**
     * check collisions
     */
    public void act()
    {    

    }

    /**
     * Collision detection for humans.
     */
    public boolean collideHuman(Human h1, Human h2)
    {
        if((h1.left <= h2.right && h1.right >= h2.left) || (h1.right >= h2.left && h1.left <= h2.right))
        {
            if(h1.top <= h2.bottom && h1.bottom >= h2.top)
            {

                return true;
            }
        }
        return false;
    }

    /**
     * Collision detection for Pairs and Rings.
     */
    public boolean collideRing(Human h1, Ring h2)
    {
        if((h1.left <= h2.right && h1.right >= h2.left) || (h1.right >= h2.left && h1.left <= h2.right))
        {
            if(h1.top <= h2.bottom && h1.bottom >= h2.top)
            {
                return true;
            }
        }
        return false;
    }

    public void playSound(Human h1, Human h2)
    {
        if(h1 == null || h2 == null)
        {
            return;
        }
        beatTick++;
        if(paired && !beat.isPlaying())
        {
            beat.play();
        }
        else if (!beat.isPlaying() && (beatTick >= (dist(h1, h2)/3)))
        {
            beat.play();
            beatTick=0;
        }
    }

    /**
     * calculates the distance between Humans. used for heartbeat rate in playSound
     */
    public double dist(Human h1, Human h2)
    {
        return Math.sqrt(Math.pow((h1.getX()-h2.getX()), 2) + Math.pow((h1.getY() - h2.getY()), 2));
    }

    /**
     * checks player collision against jerks and Intolerants.
     */
    public boolean jerkCollide(Human h1, int k)
    {
        List<Jerk> jerklist = ((List<Jerk>)getObjects(Jerk.class));
        for(Jerk j : jerklist)
        {
            if(collideHuman(h1, j))
            {
                return true;
            }
        }

        List<Intolerant> ilist = ((List<Intolerant>)getObjects(Intolerant.class));
        for(Intolerant i : ilist)
        {
            if(collideHuman(h1, i) && !isHetero(k))
            {
                return true;
            }
        }
        return false;
    }

    /**
     * Checks to see if Intolerants are dangerous to the player. Used in jerkCollide.
     */
    public boolean isHetero(int levelKey)
    {
        if(levelKey == 1 || levelKey == 2 || levelKey == 3 || levelKey == 4 || levelKey == 5|| levelKey == 10)
        {
            return true;
        }
        return false;
    }

    /**
     * return the player/pair
     */
    public Human getPlayer()
    {
        if(paired)
        {
            System.out.println("paired:");
            System.out.println(pair);
            return pair;
        }
        else
        {
            System.out.println("player:");
            System.out.println(player);
            return player;
        }
    }

    public boolean getPaired()
    {
        return paired;
    }
}
