import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo) 
/** 
 * The first level
 * 
 * @author (Cameron Olson) 
 * @version (0.01)
 */
public class Level1 extends Level
{
    Lover lover;
    Ring ring;
    
    
    /**
     * Constructor for objects of class Level1.
     */
    public Level1()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super();
        key = 1;
        
        player = new Player(key);
        addObject(player, 100, 300);
        player.setBounds();
        lover = new Lover(key);
        addObject(lover, 400, 300);
        lover.setBounds();
        ring = new Ring();
        addObject(ring, 600, 300);
        pair = new Pair(key);    
    }
    
    public void act()
    {
        checkPair();
        checkRing();
        playSound(player, lover);
        checkLose();
    }
    
    /**
     * checks to see if the pair has formed. Creates Pair.
     */
    public void checkPair()
    {
        if(!paired && collideHuman(player, lover))
        {
            paired = true;
            addObject(pair, lover.getX(), lover.getY());
            removeObject(player);
            removeObject(lover);
        }
    }
    
    /**
     * checks to see if the pair has collided with the ring. (AKA the level is finished)
     */
    public void checkRing()
    {
        if(paired && collideRing(pair, ring))
        {
            Greenfoot.setWorld(new Level2());
        }
    }
    
    /**
     * checks to see if the player has collided with a Jerk or Intolerant.
     */
    public void checkLose()
    {
        if(paired)
        {
            if(jerkCollide(pair, key))
            {
                Greenfoot.setWorld(new Level1());
            }
        }
        else if(jerkCollide(player, key))
        {
            Greenfoot.setWorld(new Level1());
        }
    }
    
}
